Index: /LMDZ6/trunk/libf/phylmd/Dust/phys_output_write_spl_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/Dust/phys_output_write_spl_mod.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/Dust/phys_output_write_spl_mod.F90	(revision 4056)
@@ -381,5 +381,5 @@
     USE pbl_surface_mod, ONLY: snow
     USE indice_sol_mod, ONLY: nbsrf
-    USE infotrac, ONLY: nqtot, nqo, nbtr, type_trac
+    USE infotrac, ONLY: nqtot, nbtr, type_trac
     USE geometry_mod, ONLY: cell_area
     USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, landice_opt
@@ -430,5 +430,5 @@
     INTEGER, PARAMETER :: jjmp1=jjm+1-1/jjm
     INTEGER :: itau_w
-    INTEGER :: i, iinit, iinitend=1, iff, iq, nsrf, k, ll, naero
+    INTEGER :: i, iinit, iinitend=1, iff, iq, itr, nsrf, k, ll, naero
     REAL, DIMENSION (klon) :: zx_tmp_fi2d
     REAL, DIMENSION (klon,klev) :: zx_tmp_fi3d, zpt_conv
@@ -1610,35 +1610,32 @@
 #endif
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-       IF (nqtot.GE.nqo+1) THEN
-         !AS: type_trac = 'lmdz' par defaut dans libf/dyn3d/conf_gcm.F90
-         !Changé par inca, repr(obus), coag(ulation), co2i(nteractif), PAS par SPLA
-         !Cet "if" est donc inutile : IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
-           DO iq=nqo+1,nqtot
-             CALL histwrite_phy(o_trac(iq-nqo), tr_seri(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_vdf(iq-nqo),d_tr_cl(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_the(iq-nqo),d_tr_th(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_con(iq-nqo),d_tr_cv(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_lessi_impa(iq-nqo),d_tr_lessi_impa(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_lessi_nucl(iq-nqo),d_tr_lessi_nucl(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_insc(iq-nqo),d_tr_insc(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_bcscav(iq-nqo),d_tr_bcscav(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_evapls(iq-nqo),d_tr_evapls(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_ls(iq-nqo),d_tr_ls(:,:,iq-nqo))
-!            CALL histwrite_phy(o_dtr_dyn(iq-nqo),d_tr_dyn(:,:,iq-nqo))
-!            CALL histwrite_phy(o_dtr_cl(iq-nqo),d_tr_cl(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_trsp(iq-nqo),d_tr_trsp(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_sscav(iq-nqo),d_tr_sscav(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_sat(iq-nqo),d_tr_sat(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_uscav(iq-nqo),d_tr_uscav(:,:,iq-nqo))
+           itr = 0
+           DO iq = 1, nqtot
+             IF(tracers(iq)%isH2Ofamily) CYCLE
+             itr = itr+1
+             CALL histwrite_phy(o_trac(itr), tr_seri(:,:,itr))
+             CALL histwrite_phy(o_dtr_vdf(itr),d_tr_cl(:,:,itr))
+             CALL histwrite_phy(o_dtr_the(itr),d_tr_th(:,:,itr))
+             CALL histwrite_phy(o_dtr_con(itr),d_tr_cv(:,:,itr))
+             CALL histwrite_phy(o_dtr_lessi_impa(itr),d_tr_lessi_impa(:,:,itr))
+             CALL histwrite_phy(o_dtr_lessi_nucl(itr),d_tr_lessi_nucl(:,:,itr))
+             CALL histwrite_phy(o_dtr_insc(itr),d_tr_insc(:,:,itr))
+             CALL histwrite_phy(o_dtr_bcscav(itr),d_tr_bcscav(:,:,itr))
+             CALL histwrite_phy(o_dtr_evapls(itr),d_tr_evapls(:,:,itr))
+             CALL histwrite_phy(o_dtr_ls(itr),d_tr_ls(:,:,itr))
+!            CALL histwrite_phy(o_dtr_dyn(itr),d_tr_dyn(:,:,itr))
+!            CALL histwrite_phy(o_dtr_cl(itr),d_tr_cl(:,:,itr))
+             CALL histwrite_phy(o_dtr_trsp(itr),d_tr_trsp(:,:,itr))
+             CALL histwrite_phy(o_dtr_sscav(itr),d_tr_sscav(:,:,itr))
+             CALL histwrite_phy(o_dtr_sat(itr),d_tr_sat(:,:,itr))
+             CALL histwrite_phy(o_dtr_uscav(itr),d_tr_uscav(:,:,itr))
              zx_tmp_fi2d=0.
              IF (vars_defined) THEN
                 DO k=1,klev
-                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,iq-nqo)
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,itr)
                 ENDDO
              ENDIF
-             CALL histwrite_phy(o_trac_cum(iq-nqo), zx_tmp_fi2d)
+             CALL histwrite_phy(o_trac_cum(itr), zx_tmp_fi2d)
            ENDDO
-         !ENDIF
-       ENDIF
 
        IF (.NOT.vars_defined) THEN
Index: /LMDZ6/trunk/libf/phylmd/Dust/phytracr_spl_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 4056)
@@ -1104,5 +1104,5 @@
       REAL, intent(in) ::  rlon(klon)       ! longitudes pour chaque point 
 !
-      INTEGER i, k, it, j, ig 
+      INTEGER i, k, iq, itr, j, ig 
 !
 ! DEFINITION OF DIAGNOSTIC VARIABLES
@@ -1260,7 +1260,10 @@
 
 #ifdef IOPHYS_DUST
-      do it=1,nbtr
-         write(str2,'(i2.2)') it
-         call iophys_ecrit('TRA'//str2,klev,'SOURCE','',tr_seri(:,:,it))
+      itr = 0
+      DO iq = 1, nqtot
+         IF(tracers(iq)%isH2Ofamily) CYCLE
+         itr = itr+1
+         write(str2,'(i2.2)') itr
+         call iophys_ecrit('TRA'//str2,klev,'SOURCE','',tr_seri(:,:,itr))
       enddo
 #endif
@@ -1414,21 +1417,23 @@
         id_codu=-1
         id_scdu=-1
-       !print *,nbtr
-       do it=1,nbtr
-        print *, it, tracers(it+nqo)%name
-        SELECT CASE(tracers(it+nqo)%name)
-          CASE('PREC'); id_prec=it
-          CASE('FINE'); id_fine=it
-          CASE('COSS'); id_coss=it
-          CASE('CODU'); id_codu=it
-          CASE('SCDU'); id_scdu=it
-        END SELECT
-       enddo
-       ! check consistency with dust emission scheme:
-       if (ok_chimeredust) then
+        itr = 0
+        do iq=1,nqtot
+          IF(tracers(iq)%isH2Ofamily) CYCLE
+          itr = itr+1
+          print *, itr, TRIM(tracers(iq)%name)
+          SELECT CASE(tracers(iq)%name)
+            CASE('PREC'); id_prec=itr
+            CASE('FINE'); id_fine=itr
+            CASE('COSS'); id_coss=itr
+            CASE('CODU'); id_codu=itr
+            CASE('SCDU'); id_scdu=itr
+          END SELECT
+        enddo
+        ! check consistency with dust emission scheme:
+        if (ok_chimeredust) then
           if (.not.( id_scdu>0 .and. id_codu>0 .and. id_fine>0)) then
              call abort_gcm('phytracr_mod', 'pb in ok_chimdust 0',1)
           endif
-       else 
+        else 
           if (id_scdu>0) then 
        call abort_gcm('phytracr_mod', 'pb in ok_chimdust 1 SCDU',1)
@@ -1560,9 +1565,9 @@
 ! JE before put in zero
       IF (lminmax) THEN
-        DO it=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,it),qmin,qmax,'nan init phytracr')
-        ENDDO        
-        DO it=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,it),qmin,qmax,'minmax init phytracr')
+        DO itr=1,nbtr
+        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan init phytracr')
+        ENDDO
+        DO itr=1,nbtr
+        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'minmax init phytracr')
         ENDDO
         CALL minmaxsource(source_tr,qmin,qmax,'maxsource init phytracr')
Index: /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_5wv_rrtm.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_5wv_rrtm.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_5wv_rrtm.F90	(revision 4056)
@@ -9,5 +9,5 @@
   USE DIMPHY
   USE aero_mod
-  USE infotrac_phy
+  USE infotrac_phy, ONLY: nqtot, nbtr, tracers
   USE phys_local_var_mod, ONLY: od550aer,od865aer,ec550aer,od550lt1aer
   !
@@ -34,5 +34,5 @@
   LOGICAL :: soluble
   
-  INTEGER :: i, k, m, itr, irh, aerindex
+  INTEGER :: i, k, m, iq, itr, irh, aerindex
   INTEGER :: spsol, spinsol, la
   INTEGER :: RH_num(klon,klev)
@@ -112,6 +112,9 @@
   ENDDO
 
-  DO itr=1,nbtr    !--loop over tracers  
-    SELECT CASE(tracers(itr+nqo)%name)
+  itr = 0
+  DO iq = 1, nqtot
+    IF(tracers(iq)%isH2Ofamily) CYCLE
+    itr = itr+1
+    SELECT CASE(tracers(iq)%name)
       CASE('PREC'); CYCLE                                  !--precursor
       CASE('FINE'); soluble=.TRUE.;  spsol=1; aerindex=1   !--fine mode accumulation mode
@@ -119,5 +122,5 @@
       CASE('CODU'); soluble=.FALSE.; spsol=1; aerindex=3   !--coarse mode dust
       CASE('SCDU'); soluble=.FALSE.; spsol=2; aerindex=4   !--super coarse mode dust
-      CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(itr+nqo)%name,1)
+      CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(iq)%name,1)
     END SELECT
 
Index: /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_6bands_rrtm.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_6bands_rrtm.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_6bands_rrtm.F90	(revision 4056)
@@ -8,5 +8,5 @@
   USE dimphy
   USE aero_mod
-  USE infotrac_phy
+  USE infotrac_phy, ONLY: nqtot, nbtr, tracers
   USE phys_local_var_mod, ONLY: abs550aer
 
@@ -35,5 +35,5 @@
   !
   LOGICAL :: soluble
-  INTEGER :: i, k, irh, itr, inu
+  INTEGER :: i, k, irh, iq, itr, inu
   INTEGER :: aerindex, spsol, spinsol
   INTEGER :: RH_num(klon,klev)
@@ -165,6 +165,9 @@
   cg_ae(:,:,:,:)=0.
     
-  DO itr=1,nbtr    !--loop over tracers  
-    SELECT CASE(tracers(itr+nqo)%name)
+  itr = 0
+  DO iq = 1, nqtot
+    IF(tracers(iq)%isH2Ofamily) CYCLE
+    itr = itr+1
+    SELECT CASE(tracers(iq)%name)
       CASE('PREC'); CYCLE                                  !--precursor
       CASE('FINE'); soluble=.TRUE.;  spsol=1; aerindex=1   !--fine mode accumulation mode
@@ -172,5 +175,5 @@
       CASE('CODU'); soluble=.FALSE.; spsol=1; aerindex=3   !--coarse mode dust
       CASE('SCDU'); soluble=.FALSE.; spsol=2; aerindex=4   !--super coarse mode dust
-      CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(itr+nqo)%name,1)
+      CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(iq)%name,1)
     END SELECT
 
Index: /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_lw_rrtm.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_lw_rrtm.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/Dust/splaeropt_lw_rrtm.F90	(revision 4056)
@@ -10,5 +10,5 @@
   USE dimphy
   USE aero_mod
-  USE infotrac_phy
+  USE infotrac_phy, ONLY: nqtot, nbtr, tracers
   USE phys_state_var_mod, ONLY : tau_aero_lw_rrtm
   USE YOERAD, ONLY : NLW
@@ -30,5 +30,5 @@
   INTEGER, PARAMETER :: naero=naero_soluble+naero_insoluble
   !
-  INTEGER inu, itr, spinsol
+  INTEGER inu, itr, iq, spinsol
   CHARACTER*20 modname
   !
@@ -54,10 +54,14 @@
     tau_aero_lw_rrtm = 0.0
     !
-    DO itr=1,nbtr
-      SELECT CASE(tracers(itr+nqo)%name)
-        CASE('PREC','FINE''COSS'); CYCLE                   !--precursor or fine/coarde accumulation mode
+    
+    itr = 0
+    DO iq = 1, nqtot
+      IF(tracers(iq)%isH2Ofamily) CYCLE
+      itr = itr+1
+      SELECT CASE(tracers(iq)%name)
+        CASE('PREC','FINE','COSS'); CYCLE                  !--precursor or fine/coarde accumulation mode
         CASE('CODU'); spinsol=1                            !--coarse mode dust
         CASE('SCDU'); spinsol=2                            !--super coarse mode dust
-        CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(itr+nqo)%name,1)
+        CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(iq)%name,1)
       END SELECT
       !
Index: /LMDZ6/trunk/libf/phylmd/Dust/splaerosol_optic_rrtm.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/Dust/splaerosol_optic_rrtm.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/Dust/splaerosol_optic_rrtm.F90	(revision 4056)
@@ -13,5 +13,5 @@
   USE dimphy
   USE aero_mod
-  USE infotrac_phy
+  USE infotrac_phy, ONLY: nbtr, nqtot, tracers
   USE YOMCST, ONLY: RD, RG
 
@@ -40,5 +40,5 @@
   REAL, DIMENSION(klon,klev,nwave,naero_tot), INTENT(OUT)  :: tau3d_aero
 
-  INTEGER i, k, itr
+  INTEGER i, k, iq, itr
   REAL, DIMENSION(klon,klev) :: zdm, zdh
   REAL zrho, pdel
@@ -50,6 +50,9 @@
   mass_solu_aero_pi(:,:) = 0.0
   !
-  DO itr=1,nbtr
-    IF (tracers(itr+nqo)%name=='FINE') THEN
+  itr = 0
+  DO iq = 1, nqtot
+    IF(tracers(iq)%isH2Ofamily) CYCLE
+    itr = itr+1
+    IF(tracers(iq)%name/='FINE') THEN
       mass_solu_aero(:,:)    = tr_seri(:,:,itr)
       mass_solu_aero_pi(:,:) = tr_seri(:,:,itr)
Index: /LMDZ6/trunk/libf/phylmd/infotrac_phy.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/infotrac_phy.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/infotrac_phy.F90	(revision 4056)
@@ -26,29 +26,19 @@
 !$OMP THREADPRIVATE(nqtottr)
 
-! ThL : number of CO2 tracers			ModThL
+! ThL : number of CO2 tracers   ModThL
   INTEGER, SAVE :: nqCO2
 !$OMP THREADPRIVATE(nqCO2)
 
 #ifdef CPP_StratAer
-! nbtr_bin: number of aerosol bins for StratAer model
-! nbtr_sulgas: number of sulfur gases for StratAer model
-  INTEGER, SAVE :: nbtr_bin, nbtr_sulgas
-!$OMP THREADPRIVATE(nbtr_bin,nbtr_sulgas)
-  INTEGER, SAVE :: id_OCS_strat, id_SO2_strat, id_H2SO4_strat, id_BIN01_strat
-!$OMP THREADPRIVATE(id_OCS_strat, id_SO2_strat, id_H2SO4_strat, id_BIN01_strat)
+  !=== SPECIFIC TO STRATOSPHERIC AEROSOLS (CK/OB)
+  INTEGER, SAVE ::  nbtr_bin, nbtr_sulgas         !--- number of aerosols bins and sulfur gases for StratAer model
+!$OMP THREADPRIVATE(nbtr_bin, nbtr_sulgas)
+  INTEGER, SAVE ::  id_OCS_strat, id_SO2_strat, id_H2SO4_strat, id_BIN01_strat, id_TEST_strat
+!$OMP THREADPRIVATE(id_OCS_strat, id_SO2_strat, id_H2SO4_strat, id_BIN01_strat, id_TEST_strat)
 #endif
-
-! CRisi: nb traceurs pères= directement advectés par l'air
-  INTEGER, SAVE :: nqperes
-!$OMP THREADPRIVATE(nqperes)
 
 ! Tracers parameters
   TYPE(trac_type), TARGET, ALLOCATABLE, SAVE :: tracers(:)
 !$OMP THREADPRIVATE(tracers)
-
-! niadv : vector keeping the coorspondance between all tracers(nqtot) treated in the 
-!         dynamic part of the code and the tracers (nbtr+2) used in the physics part of the code. 
-  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: niadv ! equivalent dyn / physique
-!$OMP THREADPRIVATE(niadv)
 
 ! conv_flg(it)=0 : convection desactivated for tracer number it 
@@ -85,21 +75,13 @@
 !$OMP THREADPRIVATE(niso,ntraceurs_zone,ntraciso)
 
-    INTEGER, ALLOCATABLE, DIMENSION(:), SAVE ::  itr_indice ! numéro iq entre 1 et nqtot qui correspond au traceur itr entre 1 et nqtottr
-!$OMP THREADPRIVATE(itr_indice)
- 
 CONTAINS
 
   SUBROUTINE init_infotrac_phy(nqtot_,nqo_,nbtr_,nqtottr_,nqCO2_,tracers_,type_trac_,&
-                               niadv_,conv_flg_,pbl_flg_,solsym_,&
+                               conv_flg_,pbl_flg_,solsym_,&
                                ok_isotopes_,ok_iso_verif_,ok_isotrac_,&
                                ok_init_iso_,niso_possibles_,tnat_,&
                                alpha_ideal_,use_iso_,iqiso_,iso_indnum_,&
                                indnum_fn_num_,index_trac_,&
-                               niso_,ntraceurs_zone_,ntraciso_,itr_indice_&
-#ifdef CPP_StratAer
-                               ,nbtr_bin_,nbtr_sulgas_&
-                               ,id_OCS_strat_,id_SO2_strat_,id_H2SO4_strat_,id_BIN01_strat_&
-#endif
-                               )
+                               niso_,ntraceurs_zone_,ntraciso_)
 
     ! transfer information on tracers from dynamics to physics
@@ -112,15 +94,6 @@
     INTEGER,INTENT(IN) :: nqtottr_
     INTEGER,INTENT(IN) :: nqCO2_
-#ifdef CPP_StratAer
-    INTEGER,INTENT(IN) :: nbtr_bin_
-    INTEGER,INTENT(IN) :: nbtr_sulgas_
-    INTEGER,INTENT(IN) :: id_OCS_strat_
-    INTEGER,INTENT(IN) :: id_SO2_strat_
-    INTEGER,INTENT(IN) :: id_H2SO4_strat_
-    INTEGER,INTENT(IN) :: id_BIN01_strat_
-#endif
     TYPE(trac_type), INTENT(IN) :: tracers_(nqtot_) ! tracers descriptors
     CHARACTER(len=*),INTENT(IN) :: type_trac_
-    INTEGER,INTENT(IN) :: niadv_ (nqtot_) ! equivalent dyn / physique
     INTEGER,INTENT(IN) :: conv_flg_(nbtr_)
     INTEGER,INTENT(IN) :: pbl_flg_(nbtr_)
@@ -142,7 +115,8 @@
     INTEGER,INTENT(IN) :: ntraceurs_zone_
     INTEGER,INTENT(IN) :: ntraciso_
-    INTEGER,INTENT(IN) :: itr_indice_(nqtottr_)
-
-    CHARACTER(LEN=30) :: modname="init_infotrac_phy"
+
+    INTEGER :: iq, itr
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
+    CHARACTER(LEN=maxlen) :: modname="init_infotrac_phy"
 
     nqtot=nqtot_
@@ -153,14 +127,23 @@
     ALLOCATE(tracers(nqtot)); tracers(:) = tracers_(:)
 #ifdef CPP_StratAer
-    nbtr_bin=nbtr_bin_
-    nbtr_sulgas=nbtr_sulgas_
-    id_OCS_strat=id_OCS_strat_
-    id_SO2_strat=id_SO2_strat_
-    id_H2SO4_strat=id_H2SO4_strat_
-    id_BIN01_strat=id_BIN01_strat_
+    IF (type_trac == 'coag') THEN
+      nbtr_bin    = COUNT([(tracers(iq)%name(1:3)=='BIN', iq=1, nqtot)])
+      nbtr_sulgas = COUNT([(tracers(iq)%name(1:3)=='GAS', iq=1, nqtot)])
+      tnames = PACK(tracers(:)%name, MASK=.NOT.tracers(:)%isH2Ofamily)
+      id_BIN01_strat = strIdx(tnames, 'BIN01'   )
+      id_OCS_strat   = strIdx(tnames, 'GASOSC'  )
+      id_SO2_strat   = strIdx(tnames, 'GASSO2'  )
+      id_H2SO4_strat = strIdx(tnames, 'GASH2SO4')
+      id_TEST_strat  = strIdx(tnames, 'GASTEST' )
+      WRITE(lunout,*)'nbtr_bin       =', nbtr_bin
+      WRITE(lunout,*)'nbtr_sulgas    =', nbtr_sulgas
+      WRITE(lunout,*)'id_BIN01_strat =', id_BIN01_strat
+      WRITE(lunout,*)'id_OCS_strat   =',   id_OCS_strat
+      WRITE(lunout,*)'id_SO2_strat   =',   id_SO2_strat
+      WRITE(lunout,*)'id_H2SO4_strat =', id_H2SO4_strat
+      WRITE(lunout,*)'id_TEST_strat  =',  id_TEST_strat
+    END IF
 #endif
     type_trac = type_trac_
-    ALLOCATE(niadv(nqtot))
-    niadv(:)=niadv_(:)
     ALLOCATE(conv_flg(nbtr))
     conv_flg(:)=conv_flg_(:)
@@ -207,7 +190,11 @@
     ENDIF ! of IF(ok_isotopes)
 
-    ALLOCATE(itr_indice(nqtottr))
-    itr_indice(:)=itr_indice_(:)
-  
+    WRITE(*,*) 'infotrac_phy 207: nqtottr=',nqtottr
+    WRITE(*,*) 'ntraciso,niso=',ntraciso,niso
+#ifdef ISOVERIF
+    ! DC: the "1" will be replaced by iH2O (H2O isotopes group index)
+    WRITE(*,*) 'iso_iName=',PACK(tracers(:)%iso_iName, MASK=tracers(:)%iso_iGroup==1)
+#endif
+
   END SUBROUTINE init_infotrac_phy
 
Index: /LMDZ6/trunk/libf/phylmd/init_be.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/init_be.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/init_be.F90	(revision 4056)
@@ -5,5 +5,4 @@
 
   USE dimphy
-  USE infotrac_phy, ONLY : nbtr
   USE indice_sol_mod
   USE geometry_mod, ONLY : longitude, latitude
Index: /LMDZ6/trunk/libf/phylmd/phyetat0.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phyetat0.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/phyetat0.F90	(revision 4056)
@@ -21,11 +21,11 @@
        ale_wake, ale_bl_stat, ds_ns, dt_ns, delta_sst, delta_sal, ratqs_inter
 !FC
-  USE geometry_mod, ONLY : longitude_deg, latitude_deg
-  USE iostart, ONLY : close_startphy, get_field, get_var, open_startphy
-  USE infotrac_phy, only: nbtr, nqo, type_trac, tracers, niadv
-  USE traclmdz_mod,    ONLY : traclmdz_from_restart
-  USE carbon_cycle_mod, ONLY : carbon_cycle_tr, carbon_cycle_cpl, co2_send
-  USE indice_sol_mod, only: nbsrf, is_ter, epsfra, is_lic, is_oce, is_sic
-  USE ocean_slab_mod, ONLY: nslay, tslab, seaice, tice, ocean_slab_init
+  USE geometry_mod,     ONLY: longitude_deg, latitude_deg
+  USE iostart,          ONLY: close_startphy, get_field, get_var, open_startphy
+  USE infotrac_phy,     ONLY: nqtot, nbtr, type_trac, tracers
+  USE traclmdz_mod,     ONLY: traclmdz_from_restart
+  USE carbon_cycle_mod, ONLY: carbon_cycle_tr, carbon_cycle_cpl, co2_send
+  USE indice_sol_mod,   ONLY: nbsrf, is_ter, epsfra, is_lic, is_oce, is_sic
+  USE ocean_slab_mod,   ONLY: nslay, tslab, seaice, tice, ocean_slab_init
   USE time_phylmdz_mod, ONLY: init_iteration, pdtphys, itau_phy
 #ifdef CPP_XIOS
@@ -75,5 +75,5 @@
   INTEGER length
   PARAMETER (length=100)
-  INTEGER it, iiq, isw
+  INTEGER it, iq, isw
   REAL tab_cntrl(length), tabcntr0(length)
   CHARACTER*7 str7
@@ -448,13 +448,15 @@
 
   IF (type_trac == 'lmdz') THEN
-     DO it=1, nbtr                                                                  
-!!        iiq=niadv(it+2)                                                           ! jyg
-        iiq=niadv(it+nqo)                                                           ! jyg
-        found=phyetat0_get(1,trs(:,it),"trs_"//TRIM(tracers(iiq)%name), &
-                                  "Surf trac"//TRIM(tracers(iiq)%name),0.)
-     ENDDO
+     it = 0
+     DO iq = 1, nqtot
+        IF(.NOT.tracers(iq)%isAdvected .OR. tracers(iq)%isH2Ofamily) CYCLE
+        it = it+1
+        found=phyetat0_get(1,trs(:,it),"trs_"//TRIM(tracers(iq)%name), &
+                                  "Surf trac"//TRIM(tracers(iq)%name),0.)
+     END DO
      CALL traclmdz_from_restart(trs)
   ENDIF
 
+!--OB now this is for co2i - ThL: and therefore also for inco
   IF (type_trac == 'co2i' .OR. type_trac == 'inco') THEN
      IF (carbon_cycle_cpl) THEN
@@ -598,5 +600,5 @@
    CALL get_field(name, field, found)
    IF (.NOT. found) THEN
-     WRITE(lunout,*) "phyetat0: Le champ <",name,"> est absent"
+     WRITE(lunout,*) "phyetat0: Le champ <",TRIM(name),"> est absent"
      WRITE(lunout,*) "Depart legerement fausse. Mais je continue"
      field(:,:)=default
Index: /LMDZ6/trunk/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phyredem.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/phyredem.F90	(revision 4056)
@@ -35,5 +35,5 @@
   USE iostart, ONLY: open_restartphy, close_restartphy, enddef_restartphy, put_field, put_var
   USE traclmdz_mod, ONLY : traclmdz_to_restart
-  USE infotrac_phy, ONLY: type_trac, niadv, tracers, nbtr, nqo
+  USE infotrac_phy, ONLY: type_trac, nqtot, tracers, nbtr
   USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, co2_send
   USE indice_sol_mod, ONLY: nbsrf, is_oce, is_sic, is_ter, is_lic, epsfra
@@ -70,5 +70,5 @@
   CHARACTER (len=2) :: str2
   CHARACTER (len=256) :: nam, lnam
-  INTEGER           :: it, iiq, pass
+  INTEGER           :: it, iq, pass
 
   !======================================================================
@@ -326,8 +326,9 @@
     IF (type_trac == 'lmdz') THEN
        CALL traclmdz_to_restart(trs)
-       DO it=1, nbtr
-!!        iiq=niadv(it+2)                                                           ! jyg
-          iiq=niadv(it+nqo)                                                           ! jyg
-          CALL put_field(pass,"trs_"//tracers(iiq)%name, "", trs(:, it))
+       it = 0
+       DO iq = 1, nqtot
+          IF(.NOT.tracers(iq)%isAdvected .OR. tracers(iq)%isH2Ofamily) CYCLE
+          it = it+1
+          CALL put_field(pass,"trs_"//tracers(iq)%name, "", trs(:, it))
        END DO
     END IF
@@ -391,5 +392,5 @@
 
   IMPLICIT NONE
-  INTEGER, INTENT(IN)            :: pass
+  INTEGER, INTENT(IN)           :: pass
   CHARACTER(LEN=*),  INTENT(IN) :: nam, lnam
   REAL,              INTENT(IN) :: field(:,:)
